stages:
  - build
  - deploy_web
  - deploy

variables:
  npm_config_cache: "$CI_PROJECT_DIR/client/.npm"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - ${npm_config_cache}

build:web:
  stage: build
  tags:
    - docker
  image: node
  script:
    - cd client/
    - npm ci
    - npm run build
  artifacts:
    paths:
      - client/dist/
    expire_in: 2 days
  only:
    - prod

deploy:
  stage: deploy
  tags:
    - shell
  script:
    - ssh contentcheck@contentcheckbackend.liris.cnrs.fr "cd /srv/debunk/cc-debunk/server; git fetch; git reset --hard $CI_COMMIT_SHA; docker-compose up --build -d"
  environment:
    name: server
  only:
    - prod

deploy:web:
  stage: deploy
  dependencies:
    - build:web
  tags:
    - shell
  script:
    - cd client
    - rsync -avz --delete dist contentcheck@contentcheck.liris.cnrs.fr:/srv/debunk
  environment:
    name: web
    url: https://contentcheck.liris.cnrs.fr
  only:
    - prod
